# 固件版本要求
bianbu Desktop 2.2 rc1

# 安装说明
```
sudo apt install -y libopenblas-dev \
portaudio19-dev \
python3-dev \
ffmpeg \
python3-spacemit-ort libcjson-dev libasound2-dev
```

```
sudo apt install -y ros-dev-tools ros-humble-ros-base python3-venv ros-humble-xacro \
ros-humble-joint-state-publisher ros-humble-'tf2*' \
ros-humble-'nav*' ros-humble-slam-toolbox ros-humble-tf-transformations
```

## ydlidar_sdk
```
git clone https://github.com/YDLIDAR/YDLidar-SDK.git
```

```
cd YDLidar-SDK
mkdir build && cd build
cmake ..
cmake --build . -- -j8
sudo cmake --install .
```

# 配置 udev

```
sudo su

echo 'KERNEL=="ttyACM*", ATTRS{idVendor}=="1a86", ATTRS{idProduct}=="55d3",MODE:="0777",SYMLINK+="agv_odom"' >/etc/udev/rules.d/myagv_odom.rules

echo  'KERNEL=="ttyUSB*", ATTRS{idVendor}=="1a86", ATTRS{idProduct}=="7523",MODE:="0777",SYMLINK+="agv_lidar"' >/etc/udev/rules.d/myagv_lidar.rules

exit

sudo udevadm control --reload-rules
sudo udevadm trigger
```

# 运行命令

## 声源定位

```
ros2 run jobot_mic myagv_mic_node
```

## 小车底盘

仅开启底盘控制  
```
ros2 launch myagv_odometry myagv_only_move.launch.py
```

开启底盘控制和雷达  
```
ros2 launch myagv_odometry myagv_active.launch.py
```