#include "myagv_odometry/myAGVPi.h"

#include "rclcpp/rclcpp.hpp"
#include "geometry_msgs/msg/twist.hpp"
#include <iostream>
#include <cstring>


// void sigintHandler(int sig)
// {
//     // 关闭ROS2接口，清除资源
//     rclcpp::shutdown();
// }

// int main(int argc, char *argv[])
// {
//     // 初始化ROS节点
//     rclcpp::init(argc, argv);

//     // 创建信号处理函数
//     signal(SIGINT, sigintHandler);

//     auto node = std::make_shared<MyAGV>("myagv_odometry_node");

//     if (!node->init()) {
//         RCLCPP_ERROR(node->get_logger(), "myAGV initialized failed!");
//         return 1;
//     }
//     RCLCPP_INFO(node->get_logger(), "myAGV initialized successful!");

//     // 创建机器人底盘类，通过spin不断查询订阅话题
//     rclcpp::spin(node);
    
//     // 关闭ROS2接口，清除资源
//     rclcpp::shutdown();

//     return 0;
// }

double linearX = 0; double linearY = 0; double angularZ = 0;
void cmdVelCallback(const geometry_msgs::msg::Twist::SharedPtr msg)
{
    linearX = msg->linear.x;
    linearY = msg->linear.y;
    angularZ = msg->angular.z;
    // RCLCPP_INFO(rclcpp::get_logger("myagv_odometry_node"), "cmdCallback: linearX: %.2f, linearY: %.2f, angularZ: %.2f", linearX, linearY, angularZ);
}

int main(int argc, char* argv[])
{
    rclcpp::init(argc, argv);
    auto node = std::make_shared<MyAGV>("myagv_odometry_node");

    if (!node->init()) {
        RCLCPP_ERROR(node->get_logger(), "myAGV initialized failed!");
        return 1;
    }
    RCLCPP_INFO(node->get_logger(), "myAGV initialized successful!");

    auto sub = node->create_subscription<geometry_msgs::msg::Twist>("cmd_vel", 50, cmdVelCallback);
    rclcpp::Rate loop_rate(100);

    while (rclcpp::ok()) {
        rclcpp::spin_some(node);
        node->execute(linearX, linearY, angularZ);
        loop_rate.sleep();
    }

    rclcpp::shutdown();
    return 0;
}